// This file has been generated by Py++.

// Copyright 2004 Roman Yakovenko.
// Distributed under the Boost Software License, Version 1.0. (See
// accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#include "boost/python.hpp"
#include "boost/mpl/vector.hpp"
#include "boost/type_traits.hpp"
 
template< typename return_type, typename arg1_type, typename arg2_type, typename arg_out_type >
struct register_reduced{

    typedef register_reduced< return_type, arg1_type, arg2_type, arg_out_type > this_type;
    
    typedef typename boost::remove_reference< arg_out_type >::type arg_out_no_ref_type;
    
    typedef return_type (*function_type)( arg1_type, arg2_type, arg_out_type );
    
    static arg_out_no_ref_type
    call( function_type f, arg1_type arg1, arg2_type arg2){
        arg_out_no_ref_type out;
        f(arg1, arg2, out);
        return out;
    }
    
    register_reduced( const char* name, function_type f ){
        
        namespace bpl = boost::python;
                
        bpl::def( name
                  , bpl::make_function( 
                        boost::bind<arg_out_no_ref_type>( &this_type::call, f, _1, _2 )
                        , bpl::default_call_policies()
                        , boost::mpl::vector< arg_out_no_ref_type, arg1_type, arg2_type >() ) );        
    }
};


void sum_numbers( int i, char j, long& result ){
    result = i + j;
}

void multiply_string( const std::string& x, unsigned int i, std::string& result ){
    result.erase();
    for( unsigned int index = 0; index < i; ++index ){
        result += x;
    }
}

BOOST_PYTHON_MODULE(reducer){
    register_reduced< void, int, char, long& >::register_( "sum_numbers", &sum_numbers );
    register_reduced< void, const std::string&, unsigned int, std::string& >( "multiply_string", &multiply_string );
}
